# Rust编程指南

[为何创作本书](about.md)
[关于Rust语言](introduction.md)

## Getting started

- [牛刀小试](first_try/getting-started.md)
    - [安装Rust环境](first_try/installation.md)
    - [墙推VSCode!](first_try/editor.md)
    - [认识Cargo](first_try/cargo.md)
    - [你好，世界!](first_try/hello-world.md)

## Rust学习三部曲

- [基本概念](basic_rust/intro.md)
    - [变量与类型](basic_rust/variable-type.md)
    - [结构体、枚举](basic_rust/struct-enum.md)
    - [函数与方法](basic_rust/function-method.md)
    - [格式化输出](basic_rust/formatted-output.md)
    - [字符串、数组与切片](basic_rust/string-array-slice.md)
    - [流程控制](basic_rust/flow-control.md)
    - [返回、异常和错误](basic_rust/exception-error.md)
    - [模式匹配](basic_rust/match-pattern.md)
    - [文档注释](basic_rust/comment.md)
    - [包和模块](basic_rust/crate-module.md)
    
- [核心概念](core_concepts/intro.md)
    - [所有权](core_concepts/ownership.md)
    - [借用](core_concepts/borrowing.md)
    - [生命周期](core_concepts/lifetime.md)
    
- [进阶编程](advance_rust/intro.md)
    - [泛型](advance_rust/generitic.md)
    - [特征](advance_rust/trait.md)
    - [迭代器](advance_rust/interator.md)
    - [集合类型](advance_rust/collection.md)
    - [函数式编程](advance_rust/functional-programing.md)
    - [智能指针](advance_rust/smart-pointer.md)
    - [多线程](advance_rust/threads.md)
    - [测试](advance_rust/tests.md)
    - [错误处理](advance_rust/errors.md)
    - [宏](advance_rust/macro.md)

## 专题内容

- [代码风格](style_guide/intro.md)
    - [命名规范](style_guide/naming.md)
- [面向对象](object_oriented/intro.md)
    - [OO所需的特性](object_oriented/characteristics.md)
- [异步编程](async/intro.md)
    - [并发与并行](async/concurrency-parallelism.md)
- [Cargo详解](cargo/intro.md)
    - [配置参数](cargo/manifest.md)
- [性能调优](performance/intro.md)
    - [Benchmark性能测试](performance/benchmark.md)
- [Unsafe](unsafe/intro.md)
    - [原始指针](unsafe/raw-pointer.md)

- [宏编程](macro/intro.md)
    - [过程宏](macro/procedure-macro.md)

    
## 场景模版

- [场景示例](use-case/intro.md)